mod client;
mod field;
mod queue;
mod utils;

use client::{Client, ClientLink, Reply, Request};
use field::Field;
use queue::Message;
use std::sync::{
    mpsc::{channel, Sender},
    Arc, RwLock,
};

#[derive(Clone)]
pub struct MoreThanText {
    client_link: ClientLink,
    registry: Arc<RwLock<Vec<Sender<Message>>>>,
}

impl MoreThanText {
    pub fn new() -> Self {
        Self {
            client_link: Client::start(),
            registry: Arc::new(RwLock::new(Vec::new())),
        }
    }

    pub fn request<F>(&mut self, _session: Option<F>) -> Reply
    where
        F: Into<Field>,
    {
        let req = Request::new();
        self.client_link.forward(req)
        /*
        let req = Request::new(tx);
        self.tx.send(req.into()).unwrap();
        rx.recv().unwrap()
        */
    }
}
